# The Docker image that will be used to build your app
image: node:19

stages:
  - build-node-alfa
  - build-docker-alfa
  - deploy-alfa
  - build-node
  - build-docker
  - deploy-beta
  - build-node-stage
  - build-docker-stage
  - deploy-stage
  - build-node-prod
  - build-docker-prod
  - deploy-production
#before_script:

variables:
  DOCKER_DRIVER: overlay2
  CONTAINER_IMAGE_NAME: $CI_REGISTRY_IMAGE:$CI_ENVIRONMENT_SLUG

  # !!!!! Check this variable before use !!!!
  HOST_FOLDER: /home/devops/env-sdk-dashboard-aptos

# Main scripts
.node-build-scripts: &node-build-script
  - npm install --force
  - npm run build

.docker-build-script: &docker-build-script
    - docker build -t $CONTAINER_IMAGE_NAME .
    - docker login -u gitlab-ci-token -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker push $CONTAINER_IMAGE_NAME

.deploy-script: &deploy-script
    - cp ./docker-compose-$CI_ENVIRONMENT_SLUG.yaml $HOST_FOLDER
    - cd $HOST_FOLDER
    - docker login -u gitlab-ci-token -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker pull $CONTAINER_IMAGE_NAME
    - docker-compose -p niftsy -f docker-compose-$CI_ENVIRONMENT_SLUG.yaml up -d
    - docker-compose -p niftsy -f ../niftsy-nginx/docker-compose.yml up -d --force-recreate nginx
    - docker system prune --volumes  --force
###############################################################################################
###############################################################################################
###                      ALFA                                                               ###
###############################################################################################
build-node-app-alfa-job:
  stage: build-node-alfa
  tags:
    - envbldrdocker
  only:
    - beta
  script:
    - export
    - *node-build-script
  artifacts:
    paths:
      # The folder that contains the files to be exposed at the Page URL
      - build  
  environment:
    name: alfa
    url: https://alfa.appv1.envelop.is$PUBLIC_URL/

build-docker-image-alfa:
  image: docker:latest
  stage: build-docker-alfa
  tags:
    - envbuilder
  only:
    - beta
  script:
    - *docker-build-script
  environment:
    name: alfa
    url: https://alfa.appv1.envelop.is$PUBLIC_URL/

deploy-alfa-env-jpb:
  stage: deploy-alfa
  tags:
    - envstage
  only:
    - beta
  script:
    - export
    - *deploy-script
  environment:
    name: alfa
    url: https://alfa.appv1.envelop.is$PUBLIC_URL/

###############################################################################################
###############################################################################################
###                      BETA                                                               ###
###############################################################################################
build-node-app-beta-job:
  stage: build-node
  tags:
    - envbldrdocker
  only:
    - beta
  script:
    - *node-build-script
  artifacts:
    paths:
      # The folder that contains the files to be exposed at the Page URL
      - build  
  environment:
    name: beta
    url: https://beta.appv1.envelop.is$PUBLIC_URL/

build-docker-image-beta:
  image: docker:latest
  stage: build-docker
  tags:
    - envbuilder
  only:
    - beta
  script:
    - *docker-build-script
  environment:
    name: beta
    url: https://beta.appv1.envelop.is$PUBLIC_URL/

deploy-beta-env-jpb:
  stage: deploy-beta
  tags:
    - envstage
  only:
    - beta
  script:
    - *deploy-script
  when: manual
  environment:
    name: beta
    url: https://beta.appv1.envelop.is$PUBLIC_URL/

###############################################################################################
###############################################################################################
###                      STAGE                                                               ###
###############################################################################################
build-node-app-stage-job:
  stage: build-node-stage
  tags:
    - envbldrdocker
  only:
    - master
  script:
    - *node-build-script
  artifacts:
    paths:
      # The folder that contains the files to be exposed at the Page URL
      - build  
  environment:
    name: stage
    url: https://stage.appv1.envelop.is$PUBLIC_URL/

build-docker-image:
  image: docker:latest
  stage: build-docker-stage
  tags:
    - envbuilder
  only:
    - master
  script:
    - *docker-build-script
  environment:
    name: stage
    url: https://stage.appv1.envelop.is$PUBLIC_URL/

deploy-stgae-env-jpb:
  stage: deploy-stage
  tags:
    - envstage
  only:
    - master
  script:
    - *deploy-script
  environment:
    name: stage
    url: https://stage.appv1.envelop.is$PUBLIC_URL/

###############################################################################################
###############################################################################################
###                      PRODUCTION                                                         ###
###############################################################################################
build-node-app-prod:
  stage: build-node-prod
  tags:
    - envbldrdocker
  only:
    - master
  script:
    - *node-build-script
  artifacts:
    paths:
      # The folder that contains the files to be exposed at the Page URL
      - build  
  environment:
    name: prod
    url: https://app.envelop.is$PUBLIC_URL/

build-docker-image-prod:
  image: docker:latest
  stage: build-docker-prod
  tags:
    - envbuilder
  only:
    - master
  script:
    - *docker-build-script
  environment:
    name: prod
    url: https://app.envelop.is$PUBLIC_URL/

deploy-productionserver:
  stage: deploy-production
  tags:
    - envprodgrp
  only:
    - master
  script:
    - *deploy-script
  when: manual
  environment:
    name: prod
    url: https://app.envelop.is$PUBLIC_URL/

